#include "Smoke.h"
#include "TrackBall.h"
#include <FK/FK.h>

class SmokeModel : public fk_Model {
private:
	fk_Point		dummyShape;
	Smoke			*smoke;
public:
	SmokeModel(void)
	{
		static GLfloat	smokeCol[3] = { 0.2f, 0.2f, 0.2f };
		smoke = new Smoke(100, smokeCol);
		setShape(&dummyShape);
	};
	~SmokeModel()
	{
		delete smoke;
	};
	void init(void)
	{
		//@GLEW̏
		if ( glewInit() != GLEW_OK )
		{
			cout << "Error : GLEW̏Ɏs܂\n";
			exit(0);
		}

		smoke->LoadTexture("sample.dds");
	};

	void preShader(void)
	{
		smoke->Move();
		smoke->Render();
	};

	void postShader(void)
	{
	};
};

int main(int argc, char *argv[])
{
	Fl_Window		mainWindow(512, 512, "FK TEST");
	fk_Model		camera, blockModel, lightModel;
	fk_Light		light;
	fk_Block		block(5.0, 7.0, 4.0);
	fk_Scene		scene;
	fk_Window		window(0, 0, 512, 512);

	fk_TrackBall	tb(&window, &camera);
	SmokeModel		smokeModel;

	mainWindow.end();
	fk_InitMaterial();

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// ̂̐ݒ
	blockModel.setShape(&block);
	blockModel.setMaterial(Yellow);

	// effBXvCXgɓo^
	scene.setBlendStatus(true);
	scene.setBGColor(0.8f, 0.8f, 0.8f);
	scene.entryCamera(&camera);
	scene.entryModel(&blockModel);
	scene.entryModel(&lightModel);

	// EBhEփfBXvCXgo^
	window.setScene(&scene);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 0.0, 20.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	mainWindow.show();
	window.show();
	Fl::check();

	scene.entryModel(&smokeModel);
	smokeModel.init();

	while(true) {

		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}

		if(window.drawWindow() == 0) break;
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		if(window.getSpecialKeyStatus(FK_UP, false)) {
			smokeModel.prdScale(1.01);
		}
		if(window.getSpecialKeyStatus(FK_DOWN, false)) {
			smokeModel.prdScale(0.99);
		}
		smokeModel.glFocus(camera.getPosition());

		tb.update();
	}

	return 0;
}
